package chapter32;

import java.lang.reflect.InvocationTargetException;

import javax.swing.*;

public class EventDispatcherThreadDemo extends JApplet {
  public EventDispatcherThreadDemo() {
    add(new JLabel("Hi, it runs from an event dispatcher thread"));
  }

  /** Main method */
  public static void main(String[] args) {
	  
	Runnable doGUI = new Runnable() {
	      public void run() {
	          JFrame frame = new JFrame("EventDispatcherThreadDemo");
	          frame.add(new EventDispatcherThreadDemo());
	          frame.setLocationRelativeTo(null); // Center the frame
	          frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	          frame.setSize(200, 200);
	          frame.setVisible(true);
	          System.out.println ("Did the GUI on thread  " + Thread.currentThread().getId());
	        }
	      }; 
	      SwingUtilities.invokeLater(doGUI);
	      System.out.println ("Called Invoke later for the GUI, this should print first");
	      try {
			SwingUtilities.invokeAndWait(doGUI);
		} catch (InvocationTargetException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	      System.out.println ("Finished Invoke and wait for the GUI, this should print last");
/*    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        JFrame frame = new JFrame("EventDispatcherThreadDemo");
        frame.add(new EventDispatcherThreadDemo());
        frame.setLocationRelativeTo(null); // Center the frame
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(200, 200);
        frame.setVisible(true);
      }
    });*/
  }
}
