package chapter32;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.*;

import chapter32.ProgressBarDemo.ComputePrime;

public class ProgressBarSimple extends JApplet {
	  private static JProgressBar jpb = new JProgressBar();
	  private static JTextArea jtaResult = new JTextArea();
	  private JTextField jtfPrimeCount = new JTextField(8);
	  private JButton jbtDisplayPrime = new JButton("Display Prime");
	  
	  public ProgressBarSimple() {   
		    jpb.setStringPainted(true); // Paint the percent in a string
		    jpb.setValue(0);
		    jpb.setMaximum(100);
		    
		    jtaResult.setWrapStyleWord(true);
		    jtaResult.setLineWrap(true);
		    
		    JPanel panel = new JPanel();
		    panel.add(new JLabel("Enter the prime number count"));
		    panel.add(jtfPrimeCount);
		    panel.add(jbtDisplayPrime);
		    
		    add(jpb, BorderLayout.NORTH);
		    add(new JScrollPane(jtaResult), BorderLayout.CENTER);
		    add(panel, BorderLayout.SOUTH);
		    
		    jbtDisplayPrime.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {      
		    	  ComputePrimeThread task = new ComputePrimeThread(
		          Integer.parseInt(jtfPrimeCount.getText()), jtaResult);
		          Thread primeCalc = new Thread (task);      
		          primeCalc.start();
		      }
		    });
		  }

	  /** Task class for SwingWorker */
	  static class ComputePrimeThread implements Runnable {
	    private int count; 
	    private JTextArea result; // Textarea in the UI
	    
	    /** Construct a runnable Task */
	    public ComputePrimeThread(int count, JTextArea result) {
	      this.count = count;
	      this.result = result;
	    }
	    
	 
	   
	    /** Publish the first n primes number */
	    private void publishPrimeNumbers(int n) {    
	      int count = 0; // Count the number of prime numbers
	      int number = 2; // A number to be tested for primeness

	      // Repeatedly find prime numbers
	      while (count <= n) {
	        // Print the prime number and increase the count
	        if (isPrime(number)) {
	          count++; // Increase the count
	          //setProgress(100 * count / n); // Update progress
	          //publish(number); // Publish the prime number
	          jpb.setValue(100 * count / n);
	          jtaResult.append(" " + number);
	        }

	        // Check if the next number is prime
	        number++;
	      }
	    }

	    /** Check whether number is prime */
	    private static boolean isPrime(int number) {
	      for (int divisor = 2; divisor <= number / 2; divisor++) {
	        if (number % divisor == 0) { // If true, number is not prime
	          return false; // number is not a prime
	        }
	      }

	      return true; // number is prime
	    }

		@Override
		public void run() {
			// TODO Auto-generated method stub
			publishPrimeNumbers(count);
		}
	  }
	  

	  
}
